%{
#include "sconfig.tab.h"

int linenum = 0;
%}
%option nodebug
%%
[ \t]+		{}
#.*\n		{linenum++;}
\r?\n		{linenum++;}
chip		{return(CHIP);}
device		{return(DEVICE);}
register	{return(REGISTER);}
on		{yylval.number=1; return(BOOL);}
off		{yylval.number=0; return(BOOL);}
pci		{yylval.number=PCI; return(BUS);}
pnp		{yylval.number=PNP; return(BUS);}
i2c		{yylval.number=I2C; return(BUS);}
apic		{yylval.number=APIC; return(BUS);}
apic_cluster	{yylval.number=APIC_CLUSTER; return(BUS);}
pci_domain	{yylval.number=PCI_DOMAIN; return(BUS);}
irq		{yylval.number=IRQ; return(RESOURCE);}
drq		{yylval.number=DRQ; return(RESOURCE);}
io		{yylval.number=IO; return(RESOURCE);}
end		{return(END);}
=		{return(EQUALS);}
0x[0-9a-fA-F.]+	{yylval.string = malloc(yyleng+1); strncpy(yylval.string, yytext, yyleng); return(NUMBER);}
[0-9.]+		{yylval.string = malloc(yyleng+1); strncpy(yylval.string, yytext, yyleng); return(NUMBER);}
[0-9a-fA-F.]+	{yylval.string = malloc(yyleng+1); strncpy(yylval.string, yytext, yyleng); return(NUMBER);}
\"[^\"]+\"	{yylval.string = malloc(yyleng-1); strncpy(yylval.string, yytext+1, yyleng-2); return(STRING);}
[^ \n\t]+	{yylval.string = malloc(yyleng+1); strncpy(yylval.string, yytext, yyleng); return(STRING);}
%%
